import hashlib
from time import time

# Function to hash a password with MD5
def hash_md5(password):
    return hashlib.md5(password.encode()).hexdigest()


# Function to hash a password with SHA-1
def hash_sha1(password):
    return hashlib.sha1(password.encode()).hexdigest()


# Function to perform dictionary attack
def crack_hash(hash_to_crack, hash_function, hash_name):

    password_list = [line.rstrip() for line in open('Resources/xato-net-10-million-passwords-10000.txt')]

    start = time()
    print(f"Cracking {hash_name} hash: {hash_to_crack}")
    for password in password_list:
        # Generate the hash of the password using the specified hash function
        hashed_password = hash_function(password)
        print(f"Trying password: {password} -> {hashed_password}")
        if hashed_password == hash_to_crack:
            print(f"Success! The password is: {password}. Cracked in {time() - start} seconds")
            return password
    print("Failed to crack the hash.\n")
    return None


# Example usage
if __name__ == "__main__":

    SECRET_PASSWORD = "letmein"       # The attacker does not know this password and wants to guess it

    # Generate MD5 and SHA-1 hashes of the chosen password
    HASH_TO_BREAK = hash_md5(SECRET_PASSWORD)
    # sha1_hash = hash_sha1(password_to_hash)

    # Print the hashes
    print(f"MD5 Hash of '{SECRET_PASSWORD}': {HASH_TO_BREAK}")
    # print(f"SHA-1 Hash of '{password_to_hash}': {sha1_hash}\n")

    # Attempt to crack the hashes
    crack_hash(HASH_TO_BREAK, hash_md5, "MD5")
    # crack_hash(sha1_hash, hash_sha1, "SHA-1")
