import os
import getpass
import subprocess

# Ask the user for their username
username = input("Enter your UNISIPASS username: ")

# Ask the user for their password (hidden input)
password = getpass.getpass("Enter your UNISIPASS password: ")

# Proxy settings
proxy_ip = "172.16.0.200"
proxy_port = "312"
requirements_file = "requirements.txt"

# Create the proxy URL
proxy_url = f"https://{username}:{password}@{proxy_ip}:{proxy_port}"

# Run the pip install command with the proxy
try:
    result = subprocess.run(
        ["pip", "install", f"--proxy={proxy_url}", "-r", requirements_file],
        check=True
    )
    print("✅ Packages installed successfully.")
except subprocess.CalledProcessError:
    print("❌ Error installing packages. Please check your credentials or proxy settings.")